﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.01
@EndOfDesignText@

Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As B4XView 'ignore
	Private xui As XUI 'ignore
	Private bc As BitmapCreator
	Private xiv As B4XView
	Private XZero As Int = 0
	Private VerticalLineGap As Int = 40
	Private HorizontalLineGap As Int = 20
	Private CurrentX As Float = -1
	Private MinY = -50, MaxY = 50 As Float
	Public ValueColor As Int = 0xffff0000
	
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
	Dim iv As ImageView
	iv.Initialize("")
	xiv = iv
	mBase.AddView(xiv, 1dip, 1dip, mBase.Width - 3dip, mBase.Height - 3dip)
	bc.Initialize(xiv.Width, xiv.Height)
	bc.FillRect(xui.Color_White, bc.TargetRect)
	DrawGrid(0, bc.mWidth - 1)
	CurrentX = bc.mWidth - 5
	xiv.SetBitmap(bc.Bitmap)
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
  
End Sub

Public Sub AddPoint(dx As Float, y As Float)
	If CurrentX >= bc.mWidth - 1 Then
		Dim MovingSize As Int = 2
		Dim r As B4XRect
		r.Initialize(MovingSize, 0, bc.mWidth, bc.mHeight)
		bc.DrawBitmapCreator(bc, r, 0, 0, True)
		XZero = XZero + MovingSize
		DrawGrid(bc.mWidth - MovingSize, bc.mWidth - 1)
		CurrentX = CurrentX - MovingSize
	End If
	CurrentX = CurrentX + dx
	Dim vy As Int = YValueToYPoint(y)
	bc.SetColor(CurrentX, vy , ValueColor)
	If vy < bc.mHeight - 1 Then
		bc.SetColor(CurrentX, vy + 1, ValueColor)
	End If
End Sub

Public Sub Refresh
	xiv.SetBitmap(bc.Bitmap)
End Sub


Private Sub YValueToYPoint(y As Float) As Int
	Return Max(0, Min(bc.mHeight - 1, (y - MinY) / (MaxY - MinY) * bc.mHeight))
End Sub

Private Sub DrawGrid (Start As Int, EndIndex As Int)
	For x = Start To EndIndex
		For y = 0 To bc.mHeight-1
			If y Mod HorizontalLineGap = 0 Then
				bc.SetColor(x, y, xui.Color_Gray)
			Else
				bc.SetColor(x, y, mBase.Color)
			End If
		Next
		If (x + XZero) Mod VerticalLineGap = 0 Then
			For y = 0 To bc.mHeight - 1
				bc.SetColor(x, y, xui.Color_Gray)
			Next
		End If
		
	Next
End Sub